
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>用python做测试实现高性能测试工具(3)—优化系统架构 / iVAN</title>

    <meta name="description" content="用python做测试实现高性能测试工具(3)—优化系统架构 在上一篇中对代码进行了优化,离需求进了一步,但还是很大距离,代码进一步优化我也不知道怎么办了,不会高深的算法.只能从改进系统架构考虑. 方案3: 改变系统架构 在开始多进程之前,先简单说明一下python GIL, 之前自己对他也有些误解.因为python GIL的机制存在,同时运行的线程只有一个,但这个线程在不同时刻可以运行在不同的核上,这个调度是由操作系统完成的,如果你写个死循环,开的线程足够多,是可以把整个系统的CPU消耗干净的,此时你在Linux下通过top可以看到,us 占用的CPU不">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">用python做测试实现高性能测试工具(3)—优化系统架构</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>在上一篇中对代码进行了优化，离需求进了一步，但还是很大距离，代码进一步优化我也不知道怎么办了，不会高深的算法。只能从改进系统架构考虑。</p>
<p>　　<strong>方案3： 改变系统架构</strong></p>
<p>　　在开始多进程之前，先简单说明一下python GIL, 之前自己对他也有些误解。因为python GIL的机制存在，同时运行的线程只有一个，但这个线程在不同时刻可以运行在不同的核上，这个调度是由<a href="http://www.blogjava.net/qileilove/archive/2014/01/06/408568.html" rel="external nofollow noreferrer"><u><strong>操作系统</strong></u></a>完成的，如果你写个死循环，开的线程足够多，是可以把整个系统的CPU消耗干净的，此时你在<a href="http://www.blogjava.net/qileilove/archive/2014/01/06/408568.html" rel="external nofollow noreferrer"><u><strong>Linux</strong></u></a>下通过top可以看到，us 占用的CPU不大，但sy占用的CPU会很大，CPU主要消耗在系统调度上了。下面是<a href="http://www.blogjava.net/qileilove/archive/2014/01/06/408568.html" rel="external nofollow noreferrer"><u><strong>测试</strong></u></a>代码，大家可以试试。</p>
<table>
<tbody>
<tr>
<td>
<br />import threading</p>
<p>class MultipleThread(threading.Thread):</p>
<p>def __init__(self):</p>
<p>threading.Thread.__init__(self)</p>
<p>def run(self):</p>
<p>while 1:</p>
<p>print "here"</p>
<p>for i in xrange(100):</p>
<p>multiple_thread=MultipleThread()</p>
<p>multiple_thread.start()</p>
<p>multiple_thread.join()
</td>
</tr>
</tbody>
</table>
<p>　　既然因为GIL的存在，同时只能运行一个线程，那多线程可以提高效率，当然可以！开个3-4个线程可以明显的提高性能，大概能提高个2-3倍左右吧，但继续增加线程就是副作用了。</p>
<p>　　系统多线程的系统架构：</p>
<p>　　发送和接受都不存在瓶颈，主要瓶颈在在红线部分，decode和 encode部分。多线程改成多进程比较简单，<a href="http://www.blogjava.net/qileilove/archive/2014/01/06/408568.html" rel="external nofollow noreferrer"><u><strong>工作</strong></u></a>量不大，只要把需要多进程共享的信息，由Queue改成multiprocessing.Queue()就可以了，把继承的DiameterMsgParser(threading.Thread)改成DiameterMsgParser(multiprocessing.Process)，有个比较麻烦的是log的输出，python自带的logging模块在多进程下写同一个文件会引起混乱。这个在后面单独说明。</p>
<table>
<tbody>
<tr>
<td>
<br />import multiprocessing</p>
<p>import logging</p>
<p>class Worker(multiprocessing.Process):</p>
<p>def __init__(self,mp_name,input_queue):</p>
<p>multiprocessing.Process.__init__(self,name=mp_name)</p>
<p>self.input_queue=input_queue</p>
<p>def run(self):</p>
<p>for i in xrange(100):</p>
<p>self.input_queue.put_nowait(i)</p>
<p>logging.debug("<a href="http://www.blogjava.net/qileilove/archive/2014/01/06/408568.html" rel="external nofollow noreferrer"><u><strong>test</strong></u></a> "+str(i))
</td>
</tr>
</tbody>
</table>
<p>　　多线程改成多进程后，在sunfire 4170 (16 core , 2.4G ) 上能支持到5000 meesages (双向)， CPU占有率 30-40%，用的是标准的python2.7，因为在solaris上没安装成功pypy,所以在此机器上，我没有测试pypy对性能影响多大。但我在一个2核的linux机器上测试python和 pypy,在多进程的情况下的效率，pypy对效率的提升没有达到倍数的级别，没找到什么原因, 后面有CPU核数比较多的机器再测试下。</p>
<p>最新内容请见作者的GitHub页：http://qaseven.github.io/</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 10:34:35</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9e%b6%e6%9e%84/" title="架构">架构</a>, <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd/" title="性能">性能</a>, <a href="https://www.iamivan.net/tag/%e9%ab%98%e6%80%a7%e8%83%bd/" title="高性能">高性能</a>, <a href="https://www.iamivan.net/tag/%e6%b5%8b%e8%af%95/" title="测试">测试</a>, <a href="https://www.iamivan.net/tag/python/" title="python">python</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/%e5%a4%9a%e7%ba%bf%e7%a8%8b/" title="多线程">多线程</a>, <a href="https://www.iamivan.net/tag/thread/" title="thread">thread</a>, <a href="https://www.iamivan.net/tag/cpu/" title="cpu">cpu</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/%e5%a4%9a%e8%bf%9b%e7%a8%8b/" title="多进程">多进程</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>用python做测试实现高性能测试工具(3)—优化系统架构的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYBOElp.html" rel="bookmark">用python做测试实现高性能测试工具&lpar;1&rpar;&mdash;序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				做过几年开发或者测试开发的人员,时常会觉得很迷茫,新功能的开发或者老功能的维护,基本是在堆代码了, 做过几年测试的朋友也会有类似的想法.性能调优或者性能测试的确很考验人分析问题.解决问题的能力,知识是否全面.本人也是第一次实现高性能的测试工具, 记录下这次diameter协议测试工具的优化过程,供大家一起学习. 有些内容涉及到具体产品,做了些改动或者单独写了测试代码演示. Python用来开发高性能的测试工具的确有天然的缺陷,性能差还有GIL,无法利用多线程. 但办法总比困难多,那么多大的互联网			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQLN38z.html" rel="bookmark">大型高性能ASP&period;NET&OpenCurlyDoubleQuote;&period;NET研究&rdquo;系统架构设计</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大型动态应用系统平台主要是针对于大流量.高并发网站建立的底层系统架构.大型网站的运行需要一个可靠.安全.可扩展.易维护的应用系统平台做为支撑,以保证网站应用的平稳运行. 大型动态应用系统又可分为几个子系统: Web前端系统 负载均衡系统 数据库集群系统 缓存系统 分布式存储系统 分布式服务器管理系统 代码分发系统 Web前端系统上海企业网站设计与制作n lang=&quot;EN-US&quot;&gt;  为了达到不同应用的服务器共享.避免单点故障.集中管理.统一配置等目的,不以应用划分服 务器,而是将			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z40ElPz.html" rel="bookmark">IBM应用部署自动化工具UrbanCode Deploy系统架构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				企业应用(Enterprise Application)是指运行在操作系统和中间件之上,实现特定业务逻辑的软件发布包和业务数据.企业应用部署(Enterprise Application Deployment)是把企业应用部署在一台或多台计算机的操作系统或中间件之上,从而提供一个可供测试.培训和生产的运行环境. 企业应 用部署是软件持续交付(Continuous Delivery)的重要环节,特别是所交付的企业应用部署架构复杂(比如多机).部署环境多(比如开发.测试.生产环境)和部署频率高(比如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn81Zob.html" rel="bookmark">用python做测试实现高性能测试工具&lpar;2&rpar;&mdash;优化代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一篇中我们通过换python的解析器来优化性能.但离实际需求还很远. 方案2: 优化代码 工欲善其事,必先利其器.要优化代码,必须先找到代码的瓶颈所在,最土的方法是添加log, 或者print, 调试完成还需要删除,比较麻烦.python里面也提供了很多profile工具:profile, cProfile, hotshot, pystats, 但这些工具提供的结果可读性不是很好,不够直观的一眼就能看到那个函数或者那一行占用时间最多. python line_profiler 提供了这样的功			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwJXNmp.html" rel="bookmark">用python做测试实现高性能测试工具&lpar;5&rpar;&mdash;多进程写log</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一篇中解决了系统的性能问题,但写log又引入了问题,多进程写log会引起混乱. 查询了多进程写log 的方案, 主要有2种: 利用多进程的Queue,把log放到统一的有个log queue里面,一个单独的线程写log 起一个单独的socket server,由 这个server来接受log,并负责写log 我觉得这2重方案都太重了,很多写log的地方就需要改动了,希望找到一个方案能直接不改动老代码写log的方式,开始考虑的是每个进程单独写一个log,但这样统计数据有点小不方便. 继续探索到			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/LzJOy7b.html" rel="bookmark">Python中的文档测试模块</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了Python中的文档测试模块,代码基于Python2.x版本,需要的朋友可以参考下 如果你经常阅读Python的官方文档,可以看到很多文档都有示例代码.比如re模块就带了很多示例代码: ? 1 2 3 4 &gt;&gt;&gt; import re &gt;&gt;&gt; m = re.search('(?&lt;=abc)def', 'abcdef') &gt;&gt;&gt; m.group(0) 'def' 可以把这些示例代码在Python的交互式环境下输入并执行,结果与文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5NO6Bz.html" rel="bookmark">怎么做一个合格的测试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				试着表述一下自己的测试思路:我期望的测试时怎样来做的.  首先给一个概念,Smart Test.何为聪明的做测试,从以下几个方面来描述:  A.重视投入产出比  首先,需要明确测试实际上是一种服务,一种技术手段,它通过一些方法.手段.工具来发现产品中的缺陷,通过及时暴露缺陷推动开发去修改来提高质量.而质量本身是与测试无关的,测或者不测,质量是在生产完成的那一刻确定的.  因此在投入一定量的测试工作量的情况下,如何让测试的收益更大?答案很容易想到,尽量找出多的缺陷,找出风险高的缺陷.那么如何做到这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boRj46z.html" rel="bookmark">做个合格的测试员</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  本来想用&quot;优秀&quot;,后来想想不过&quot;合格&quot;而已.最近工作与学习的想法,内容比较碎,先记录下来.     由于有写博客的习惯,写了不少关于测试的东西,常常被别人加群或直接加QQ问问题.可能是因为我写了不少东西的缘故吧!大多数提问者会认为我一定水平很高,然后,问我是做什么测试的?用什么工具?我的回答是:主要以功能测试为主,会用到一些辅助的工具,如 fiddler.他们无不大失所望.   关于我的第一份工作的情况,我在&lt;一个测试员的工作与学习&gt;中已经说的比较详			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNnqddM.html" rel="bookmark">hibernate-用ssh写的java后台&comma;在本机上做了下并发测试&comma;才100用户并发mysql就开始报异常了&comma;怎么解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 用ssh写的java后台,在本机上做了下并发测试,才100用户并发mysql就开始报异常了,怎么解决 org.hibernate.exception.JDBCConnectionException: Cannot open connection at org.hibernate.exception.SQLStateConverter.convert(SQLStateConverter.java:97) at org.hibernate.exception.JDBCExceptionHe			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz43XLp.html" rel="bookmark" class="title">15个国外最流行的CSS框架（附下载）&lpar;1&rpar;</a>
					<div>
						15个国外最流行的CSS框架(附下载)(1)					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp86q4b.html" rel="bookmark" class="title">一种让红帽子7&period;3能支持ntfs的快速方法</a>
					<div>
						What is NTFS? 什么是NTFS NTFS is the filesystem used by Windows NT, Windows 2000, and Windows XP. NTFS是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDQOvb.html" rel="bookmark" class="title">CSS制作网页的15条常识</a>
					<div>
						首先大家应该明白,使用DIV+CSS做网页排版不是换个标签然后再去按照表格的方式去排版,而是需要做到网页制作的内容与表现的分离. 首先大家应该明白,使用DIV+CSS做网页排版不是换个标签然后再去按照 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6P1Xz.html" rel="bookmark" class="title">COM&plus; Web 服务：通过复选框路由到 XML Web Services （转）6</a>
					<div>
						services|web|xml|复选框 要建立并运行此 C# 组件,在完成编辑连接值以连接到 Microsoft SQL Server 数据库之后,需要使用 sn.exe 生成 sctrans.sn ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bokvVb.html" rel="bookmark" class="title">GWT-Ext体验之旅，第1部分&colon; GWT-Ext入门</a>
					<div>
						概述 GWT-Ext 是基于 Google Web Toolkit(GWT)和 ExtJs 的功能强大的网页开发控件库.它扩展了 GWT ,在 ExtJs 的基础上实现了有排序功能的表格(Grid). ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYElxM.html" rel="bookmark" class="title">C语言实现画图程序</a>
					<div>
						笔者在开发县级电网调度自动化系统的过程中,碰到一个要绘制电力系统一次接线图的问题.由于电力系统一次接线图比较复杂,图上有一些特殊的符号,象变压器符号.开关符号等等,用一般的编程方法来绘制比较困难,因此 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6llXz.html" rel="bookmark" class="title">《Effective C&plus;&plus;》读书笔记01：视c&plus;&plus;为一个语言联邦</a>
					<div>
						都说c++难学.确实,这是由于c++过于庞大了,Meyers将庞大的c++分成了四个部分: 1.c语言: 2.经典的面向对象c++:包括了class,封装,继承,多态,虚函数等经典的OO思想: 3.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1RjL5p.html" rel="bookmark" class="title">Symbian学习笔记&lpar;17&rpar;&mdash;&mdash;初探WebServices API的使用&lpar;上&rpar;</a>
					<div>
						很久没有学习Symbian了,今天研究一下如何使用Symbian中提供的WebService框架来SayHello. 从SDK文档中提供的资料来看这个接口似乎有点复杂,包括了Connection AP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNExa7b.html" rel="bookmark" class="title">《Programming WPF》翻译 第9章 2&period;选择一个基类</a>
					<div>
						WPF提供了很多类,当创建一个自定义元素时,你可以从这些类中派生.图9-1显示了一组可能作为类 --可能是合适的基类,并且说明了他们之间的继承关系.注意到,这决不是完整的继承关系图,只是简 单的显示了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2ZX9p.html" rel="bookmark" class="title">Windows 7开发：版本检查</a>
					<div>
						目的 在本次实验中,您将学到如何: • 围绕版本问题,使用兼容模 式来检测错误 • 正确的检测最低的操作系统版本 • 检测功能而不用检测操作系统版本 系统需求 若完成本次实验,您 必须包含以下几个组件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAadk2M.html" rel="bookmark" class="title">Python多进程机制实例详解</a>
					<div>
						  本文实例讲述了Python多进程机制.分享给大家供大家参考.具体如下: 在以前只是接触过PYTHON的多线程机制,今天搜了一下多进程,相关文章好像不是特别多.看了几篇,小试了一把.程序如下,主要内 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAg2vb.html" rel="bookmark" class="title">Win8怎样查看Metro应用大小</a>
					<div>
						对于Win8.Surface用户来说,从Windows Store里下载应用很方便.但是,由于Win8平板界面不支持右键查看文件大小,我们不清楚已安装的应用占据的硬盘空间量,这就给管理应用造成了一些小 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlR8RRz.html" rel="bookmark" class="title">excel怎么将文章的段落顺序打乱&quest;</a>
					<div>
						  在答卷的时候,我们会经常碰到作文段落排序,那么今天小编分享给大家的是,如何快速用excel将文章的段落顺序打乱?下面小编就为大家详细介绍一下,一起来看看吧! 步骤 首先打开excel会看到我们正确 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze74G8M.html" rel="bookmark" class="title">ps 曲线 色阶 曲线可以代替色阶与亮度对比度</a>
					<div>
						色阶 是以灰场白场黑场,通过调整三类像素点的明暗达到调整图片整体亮度的目的. 调整的部分有三个点,上面是直方图,通过图,可以看出整张照片像素点的分布.可以通过挪动三点,以达到调整的目的. photos ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8LZ2b.html" rel="bookmark" class="title">php使用json</a>
					<div>
						 这篇文章主要是说明 json_encode 使用时一个需要注意的细节,无论返回的是数组还是 json,都不代表这一定就是个错误的返回结果,当前端需要的数组时,数组就是正确的结果,反之亦然 在 aja ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badJQNz.html" rel="bookmark" class="title">让电脑更换主板也不必重装系统</a>
					<div>
						  很多人不想更换主板的原因之一就是换主板意味着要重新安装系统,如果你的电脑中没有太多的应用软件,重新安装Windows XP约需半小时左右,那倒还可以接受.但假如你已经安装了很多应用软件的话,重装W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42Gm1M.html" rel="bookmark" class="title">如何把书中的文字快速录入电脑</a>
					<div>
						  工具准备: 硬件: 电脑一台 数码相机 软件: word2003(其它的版本我没有实验) doPDF (百度可以搜索下载,是一款免费的PDF制作软件) AJViewer软件(在百度可以搜索下载,是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNqNwM.html" rel="bookmark" class="title">打开系统配置实用程序</a>
					<div>
						  想打开系统配置的实用程序,但不知道该如何操作,打开系统配置实用程序的方法如下: 首先以系统管理员身份登录系统.然后选择&quot;开始&quot;→&quot;运行&quot;,打开后输入Msco ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6or6b.html" rel="bookmark" class="title">sublime 左边栏主题</a>
					<div>
						问题描述 如何修改sublime左边栏主题,试过用不同的主题左边栏就是没变化,求方法					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mxo0gmb.html" rel="bookmark" class="title">css-三列布局，左右固定，中间自适应？</a>
					<div>
						问题描述 三列布局,左右固定,中间自适应? &lt;style&gt; body{ margin:0; padding:0; font-size:30px; font-weight:bold} .he ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYj79rp.html" rel="bookmark" class="title">技术大咖齐亮相：与阿里云共贺新春（视频）</a>
					<div>
						随着新年钟声的敲响,2016年已经离我们渐行渐远,2017年已经来到我们身边,金鸡报晓,恭贺新春!值此新春佳节之际,阿里云携数十位技术大咖给大家拜年了! 梨视频技术总监,刘隽 梨视频从上云的第一天开始 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7Wqrz.html" rel="bookmark" class="title">coroutine in Python Tornado and NodeJs</a>
					<div>
						yield and generator will be the front knowledge of this article. And you should also have some sense ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RW0ob.html" rel="bookmark" class="title">onbeforeunload 提示框样式</a>
					<div>
						问题描述 onbeforeunload 提示框样式 使用onbeforeunload return false 后弹出的提示框样式不好看,有没有方法修改样式? 或者有其他的方法实现 :页面跳转前提示有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRqDOp.html" rel="bookmark" class="title">碰到尴尬问题，请高手指教</a>
					<div>
						问题描述 以前写的代码保存在.CS文件里,后经编译,形成DLL文件,CS文件现已删除,现在要稍微修改一下,(数据库的访问方式变了))难道要重新写代码? 解决方案 解决方案二:反编译看看怎么实现的吧.解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4G8Jz.html" rel="bookmark" class="title">&period;net如何将gridview的一个字段赋值给delete语句</a>
					<div>
						问题描述 ss=&quot;deletefromBgtMstTblwhereBgtMstTblID=@ID&quot;;这个@ID是gridview的值stringID=GridView1.Selec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmBaAb.html" rel="bookmark" class="title">系统定时启动服务2种实现方法&lowbar;其它相关</a>
					<div>
						有方法2中 1) 1.cmd 2.at 8:32/everymonday,tuesday,wednesday,thursday,friday D:\\Program Files\Tongda\ispi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rZNxp.html" rel="bookmark" class="title">2015 年最受欢迎的 7 个系统监控工具</a>
					<div>
						随着企业的成长,相应的IT要求也随之提高.在很多公司中,很难找到在哪个方面不依赖IT的支持.随和企业对IT依赖程度的增加,有效管理和保护IT和数据设备就变得尤为重要. 系统管理是一个涵盖性术语,它指的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB3W8b.html" rel="bookmark" class="title">如何制作符合搜索引擎优化需求的网页</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 网页优化是提高网站运行效率的一个重 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBBN5z.html" rel="bookmark" class="title">c语言里面的sbrk&lpar;&rpar;函数与malloc&lpar;&rpar;函数的区别</a>
					<div>
						问题描述 c语言里面的sbrk()函数与malloc()函数的区别 c语言里面的sbrk()函数与malloc()函数的区别有哪些?最近刚看&lt;unix环境高级编程&gt;里面有,不懂,求大神详解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLWR8M.html" rel="bookmark" class="title">was无法加载struts2的配置文件，2天了无法解决</a>
					<div>
						问题描述 在was上发布了一个SSH框架做的web项目,在tomcat下面运行的是没有任何问题,现在在was上部署.启动都能成功,但是前台一访问首页(http://localhost:8080/mee ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
